
package algo;

/**
 * A Path in a Graph
 */

public interface Path extends Cloneable {

    /**
     * empty path, all n points unused.

    public static Path emptyPath(Graph g);
     */


    /**
     * standard path from point 0 to point n-1 to 0.

    public static Path standardPath(Graph g); 
     */


    /**
     * return a copy of this with maximal used array.
     */

    public Path copyMax();


    /**
     * get array of next possible paths.
     */

    public Path[] nextPaths();


    /**
     * get next possible path, reusing used array.
     * @parm pos position in unused array
     */

    public Path nextPath(int pos);


    public String toString();


    public int length();


    public int maxsize();


    public double cost();


    public Object clone(); 

    // protected static double cost(double c);

}
